Index: /pjproject/trunk/pjlib/src/pj/ssl_sock_gtls.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ssl_sock_gtls.c	(revision 5937)
+++ /pjproject/trunk/pjlib/src/pj/ssl_sock_gtls.c	(revision 5938)
@@ -1315,355 +1089,38 @@
 }
 
-
-/* When handshake completed:
- * - notify application
- * - if handshake failed, reset SSL state
- * - return PJ_FALSE when SSL socket instance is destroyed by application. */
-static pj_bool_t on_handshake_complete(pj_ssl_sock_t *ssock,
-                                       pj_status_t status)
-{
-    pj_bool_t ret = PJ_TRUE;
-
-    /* Cancel handshake timer */
-    if (ssock->timer.id == TIMER_HANDSHAKE_TIMEOUT) {
-        pj_timer_heap_cancel(ssock->param.timer_heap, &ssock->timer);
-        ssock->timer.id = TIMER_NONE;
-    }
-
-    /* Update certificates info on successful handshake */
-    if (status == PJ_SUCCESS)
-        tls_cert_update(ssock);
-
-    /* Accepting */
-    if (ssock->is_server) {
-        if (status != PJ_SUCCESS) {
-            /* Handshake failed in accepting, destroy our self silently. */
-
-            char errmsg[PJ_ERR_MSG_SIZE];
-            char buf[PJ_INET6_ADDRSTRLEN + 10];
-
-            pj_strerror(status, errmsg, sizeof(errmsg));
+static void ssl_set_state(pj_ssl_sock_t *ssock, pj_bool_t is_server)
+{
+    PJ_UNUSED_ARG(ssock);
+    PJ_UNUSED_ARG(is_server);
+}
+
+static void ssl_set_peer_name(pj_ssl_sock_t *ssock)
+{
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
+
+    /* Set server name to connect */
+    if (ssock->param.server_name.slen) {
+        int ret;
+        /* Server name is null terminated already */
+        ret = gnutls_server_name_set(gssock->session, GNUTLS_NAME_DNS,
+                                     ssock->param.server_name.ptr,
+                                     ssock->param.server_name.slen);
+        if (ret < 0) {
             PJ_LOG(3, (ssock->pool->obj_name,
-                       "Handshake failed in accepting %s: %s",
-                       pj_sockaddr_print(&ssock->rem_addr, buf,sizeof(buf),3),
-                       errmsg));
-
-            /* Workaround for ticket #985 */
-#if (defined(PJ_WIN32)&& PJ_WIN32 != 0) || (defined(PJ_WIN64)&& PJ_WIN64 != 0)
-            if (ssock->param.timer_heap) {
-                pj_time_val interval = {0, DELAYED_CLOSE_TIMEOUT};
-
-                tls_sock_reset(ssock);
-
-                ssock->timer.id = TIMER_CLOSE;
-                pj_time_val_normalize(&interval);
-                if (pj_timer_heap_schedule(ssock->param.timer_heap,
-                                           &ssock->timer, &interval) != 0)
-                {
-                    ssock->timer.id = TIMER_NONE;
-                    pj_ssl_sock_close(ssock);
-                }
-            } else
-#endif /* PJ_WIN32 */
-            {
-                pj_ssl_sock_close(ssock);
-            }
-
-            return PJ_FALSE;
-        }
-        /* Notify application the newly accepted SSL socket */
-        if (ssock->param.cb.on_accept_complete)
-            ret = (*ssock->param.cb.on_accept_complete)
-                      (ssock->parent, ssock, (pj_sockaddr_t*)&ssock->rem_addr,
-                       pj_sockaddr_get_len((pj_sockaddr_t*)&ssock->rem_addr));
-
-    } else { /* Connecting */
-        /* On failure, reset SSL socket state first, as app may try to
-         * reconnect in the callback. */
-        if (status != PJ_SUCCESS) {
-            /* Server disconnected us, possibly due to negotiation failure */
-            tls_sock_reset(ssock);
-        }
-        if (ssock->param.cb.on_connect_complete) {
-
-            ret = (*ssock->param.cb.on_connect_complete)(ssock, status);
-        }
-    }
-
-    return ret;
-}
-
-static write_data_t *alloc_send_data(pj_ssl_sock_t *ssock, pj_size_t len)
-{
-    send_buf_t *send_buf = &ssock->send_buf;
-    pj_size_t avail_len, skipped_len = 0;
-    char *reg1, *reg2;
-    pj_size_t reg1_len, reg2_len;
-    write_data_t *p;
-
-    /* Check buffer availability */
-    avail_len = send_buf->max_len - send_buf->len;
-    if (avail_len < len)
-        return NULL;
-
-    /* If buffer empty, reset start pointer and return it */
-    if (send_buf->len == 0) {
-        send_buf->start = send_buf->buf;
-        send_buf->len   = len;
-        p = (write_data_t*)send_buf->start;
-        goto init_send_data;
-    }
-
-    /* Free space may be wrapped/splitted into two regions, so let's
-     * analyze them if any region can hold the write data. */
-    reg1 = send_buf->start + send_buf->len;
-    if (reg1 >= send_buf->buf + send_buf->max_len)
-        reg1 -= send_buf->max_len;
-        reg1_len = send_buf->max_len - send_buf->len;
-    if (reg1 + reg1_len > send_buf->buf + send_buf->max_len) {
-        reg1_len = send_buf->buf + send_buf->max_len - reg1;
-        reg2 = send_buf->buf;
-        reg2_len = send_buf->start - send_buf->buf;
-    } else {
-        reg2 = NULL;
-        reg2_len = 0;
-    }
-
-    /* More buffer availability check, note that the write data must be in
-     * a contigue buffer. */
-    avail_len = PJ_MAX(reg1_len, reg2_len);
-    if (avail_len < len)
-    return NULL;
-
-    /* Get the data slot */
-    if (reg1_len >= len) {
-        p = (write_data_t*)reg1;
-    } else {
-        p = (write_data_t*)reg2;
-        skipped_len = reg1_len;
-    }
-
-    /* Update buffer length */
-    send_buf->len += len + skipped_len;
-
-init_send_data:
-    /* Init the new send data */
-    pj_bzero(p, sizeof(*p));
-    pj_list_init(p);
-    pj_list_push_back(&ssock->send_pending, p);
-
-    return p;
-}
-
-static void free_send_data(pj_ssl_sock_t *ssock, write_data_t *wdata)
-{
-    send_buf_t *buf = &ssock->send_buf;
-    write_data_t *spl = &ssock->send_pending;
-
-    pj_assert(!pj_list_empty(&ssock->send_pending));
-
-    /* Free slot from the buffer */
-    if (spl->next == wdata && spl->prev == wdata) {
-    /* This is the only data, reset the buffer */
-    buf->start = buf->buf;
-    buf->len = 0;
-    } else if (spl->next == wdata) {
-    /* This is the first data, shift start pointer of the buffer and
-     * adjust the buffer length.
-     */
-    buf->start = (char*)wdata->next;
-    if (wdata->next > wdata) {
-        buf->len -= ((char*)wdata->next - buf->start);
-    } else {
-        /* Overlapped */
-        pj_size_t right_len, left_len;
-        right_len = buf->buf + buf->max_len - (char*)wdata;
-        left_len  = (char*)wdata->next - buf->buf;
-        buf->len -= (right_len + left_len);
-    }
-    } else if (spl->prev == wdata) {
-    /* This is the last data, just adjust the buffer length */
-    if (wdata->prev < wdata) {
-        pj_size_t jump_len;
-        jump_len = (char*)wdata -
-               ((char*)wdata->prev + wdata->prev->record_len);
-        buf->len -= (wdata->record_len + jump_len);
-    } else {
-        /* Overlapped */
-        pj_size_t right_len, left_len;
-        right_len = buf->buf + buf->max_len -
-            ((char*)wdata->prev + wdata->prev->record_len);
-        left_len  = (char*)wdata + wdata->record_len - buf->buf;
-        buf->len -= (right_len + left_len);
-    }
-    }
-    /* For data in the middle buffer, just do nothing on the buffer. The slot
-     * will be freed later when freeing the first/last data. */
-
-    /* Remove the data from send pending list */
-    pj_list_erase(wdata);
-}
-
-#if 0
-/* Just for testing send buffer alloc/free */
-#include <pj/rand.h>
-pj_status_t pj_ssl_sock_ossl_test_send_buf(pj_pool_t *pool)
-{
-    enum { MAX_CHUNK_NUM = 20 };
-    unsigned chunk_size, chunk_cnt, i;
-    write_data_t *wdata[MAX_CHUNK_NUM] = {0};
-    pj_time_val now;
-    pj_ssl_sock_t *ssock = NULL;
-    pj_ssl_sock_param param;
-    pj_status_t status;
-
-    pj_gettimeofday(&now);
-    pj_srand((unsigned)now.sec);
-
-    pj_ssl_sock_param_default(&param);
-    status = pj_ssl_sock_create(pool, &param, &ssock);
-    if (status != PJ_SUCCESS) {
-        return status;
-    }
-
-    if (ssock->send_buf.max_len == 0) {
-        ssock->send_buf.buf = (char *)
-                              pj_pool_alloc(ssock->pool,
-                                            ssock->param.send_buffer_size);
-        ssock->send_buf.max_len = ssock->param.send_buffer_size;
-        ssock->send_buf.start = ssock->send_buf.buf;
-        ssock->send_buf.len = 0;
-    }
-
-    chunk_size = ssock->param.send_buffer_size / MAX_CHUNK_NUM / 2;
-    chunk_cnt = 0;
-    for (i = 0; i < MAX_CHUNK_NUM; i++) {
-        wdata[i] = alloc_send_data(ssock, pj_rand() % chunk_size + 321);
-        if (wdata[i])
-            chunk_cnt++;
-        else
-            break;
-    }
-
-    while (chunk_cnt) {
-        i = pj_rand() % MAX_CHUNK_NUM;
-        if (wdata[i]) {
-            free_send_data(ssock, wdata[i]);
-            wdata[i] = NULL;
-            chunk_cnt--;
-        }
-    }
-
-    if (ssock->send_buf.len != 0)
-        status = PJ_EBUG;
-
-    pj_ssl_sock_close(ssock);
-    return status;
-}
-#endif
-
-/* Flush write circular buffer to network socket. */
-static pj_status_t flush_circ_buf_output(pj_ssl_sock_t *ssock,
-                                         pj_ioqueue_op_key_t *send_key,
-                                         pj_size_t orig_len, unsigned flags)
-{
-    pj_ssize_t len;
-    write_data_t *wdata;
-    pj_size_t needed_len;
-    pj_status_t status;
-
-    pj_lock_acquire(ssock->circ_buf_output_mutex);
-
-    /* Check if there is data in the circular buffer, flush it if any */
-    if (circ_empty(&ssock->circ_buf_output)) {
-        pj_lock_release(ssock->circ_buf_output_mutex);
-
-        return PJ_SUCCESS;
-    }
-
-    len = circ_size(&ssock->circ_buf_output);
-
-    /* Calculate buffer size needed, and align it to 8 */
-    needed_len = len + sizeof(write_data_t);
-    needed_len = ((needed_len + 7) >> 3) << 3;
-
-    /* Allocate buffer for send data */
-    wdata = alloc_send_data(ssock, needed_len);
-    if (wdata == NULL) {
-        pj_lock_release(ssock->circ_buf_output_mutex);
-        return PJ_ENOMEM;
-    }
-
-    /* Copy the data and set its properties into the send data */
-    pj_ioqueue_op_key_init(&wdata->key, sizeof(pj_ioqueue_op_key_t));
-    wdata->key.user_data = wdata;
-    wdata->app_key = send_key;
-    wdata->record_len = needed_len;
-    wdata->data_len = len;
-    wdata->plain_data_len = orig_len;
-    wdata->flags = flags;
-    circ_read(&ssock->circ_buf_output, (pj_uint8_t *)&wdata->data, len);
-
-    /* Ticket #1573: Don't hold mutex while calling PJLIB socket send(). */
-    pj_lock_release(ssock->circ_buf_output_mutex);
-
-    /* Send it */
-    if (ssock->param.sock_type == pj_SOCK_STREAM()) {
-        status = pj_activesock_send(ssock->asock, &wdata->key,
-                                    wdata->data.content, &len,
-                                    flags);
-    } else {
-        status = pj_activesock_sendto(ssock->asock, &wdata->key,
-                                      wdata->data.content, &len,
-                                      flags,
-                                      (pj_sockaddr_t*)&ssock->rem_addr,
-                                      ssock->addr_len);
-    }
-
-    if (status != PJ_EPENDING) {
-        /* When the sending is not pending, remove the wdata from send
-         * pending list. */
-        pj_lock_acquire(ssock->circ_buf_output_mutex);
-        free_send_data(ssock, wdata);
-        pj_lock_release(ssock->circ_buf_output_mutex);
-    }
-
-    return status;
-}
-
-static void on_timer(pj_timer_heap_t *th, struct pj_timer_entry *te)
-{
-    pj_ssl_sock_t *ssock = (pj_ssl_sock_t*)te->user_data;
-    int timer_id = te->id;
-
-    te->id = TIMER_NONE;
-
-    PJ_UNUSED_ARG(th);
-
-    switch (timer_id) {
-    case TIMER_HANDSHAKE_TIMEOUT:
-        PJ_LOG(1, (ssock->pool->obj_name, "TLS timeout after %d.%ds",
-                   ssock->param.timeout.sec, ssock->param.timeout.msec));
-
-        on_handshake_complete(ssock, PJ_ETIMEDOUT);
-        break;
-    case TIMER_CLOSE:
-        pj_ssl_sock_close(ssock);
-        break;
-    default:
-        pj_assert(!"Unknown timer");
-        break;
-    }
-}
-
+                       "gnutls_server_name_set() failed: %s",
+                       gnutls_strerror(ret)));
+        }
+    }
+}
 
 /* Try to perform an asynchronous handshake */
-static pj_status_t tls_try_handshake(pj_ssl_sock_t *ssock)
-{
+static pj_status_t ssl_do_handshake(pj_ssl_sock_t *ssock)
+{
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
     int ret;
     pj_status_t status;
 
     /* Perform SSL handshake */
-    ret = gnutls_handshake(ssock->session);
+    ret = gnutls_handshake(gssock->session);
 
     status = flush_circ_buf_output(ssock, &ssock->handshake_op_key, 0, 0);
@@ -1673,5 +1130,5 @@
     if (ret == GNUTLS_E_SUCCESS) {
         /* System are GO */
-        ssock->connection_state = TLS_STATE_ESTABLISHED;
+        ssock->ssl_state = SSL_STATE_ESTABLISHED;
         status = PJ_SUCCESS;
     } else if (!gnutls_error_is_fatal(ret)) {
